<?php
/*
Plugin Name: AskApache Password Protect
Plugin URI: http://www.askapache.com/wordpress/htaccess-password-protect.html
Description: Adds Password Protection to your wp-admin directory. <a href="options-general.php?page=aa-password-protect.php">Options configuration panel</a>
Version: 1.9
Author: AskApache
Author URI: http://www.askapache.com
*/

/*
* Change Log
* 
 
* ver. 1.7 19-Aug-2007
* - added ability to turn off password protection
*
* ver. 1.6 19-Aug-2007
* - added activation and deactivation hooks
* - totally refactored
*
* ver. 1.4 15-Aug-2007
* - Cleaned up
*
* ver. 1.0 14-Aug-2007
*
define('ABSPATH', dirname(__FILE__).'/');
require_once(ABSPATH.'wp-settings.php');

*/




/*
== Installation ==

1. Extract aa-password-protect.zip into your wp-content/plugins directory into its own folder
2. Make your blog directory writeable OR create two files named sitemap.xml and sitemap.xml.gz and make them writeable via CHMOD In most cases, your blog directory is already writeable.
3. Double make sure that your blog directory is writable or two writable files named sitemap.xml and sitemap.xml.gz exist!
4. Activate it in the Plugin options
5. Edit or publish a post or click on Rebuild Sitemap on the Sitemap Administration Interface

*/




/*
/--------------------------------------------------------------------\
|                                                                    |
| License: GPL                                                       |
|                                                                    |
| AskApache Password Protect Plugin - adds password to wp-admin      |
| Copyright (C) 2007, AskApache, www.askapache.com                   |
| All rights reserved.                                               |
|                                                                    |
| This program is free software; you can redistribute it and/or      |
| modify it under the terms of the GNU General Public License        |
| as published by the Free Software Foundation; either version 2     |
| of the License, or (at your option) any later version.             |
|                                                                    |
| This program is distributed in the hope that it will be useful,    |
| but WITHOUT ANY WARRANTY; without even the implied warranty of     |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      |
| GNU General Public License for more details.                       |
|                                                                    |
| You should have received a copy of the GNU General Public License  |
| along with this program; if not, write to the                      |
| Free Software Foundation, Inc.                                     |
| 51 Franklin Street, Fifth Floor                                    |
| Boston, MA  02110-1301, USA                                        |   
|                                                                    |
\--------------------------------------------------------------------/
*/


?>
<?php




/************************************************************\
*
\************************************************************/
function aa_pass_protect_options_setup() {
    
    add_options_page('AskApache Password Protect', 'AskApache Password Protect', 10, basename(__FILE__), 'aa_pass_protect_page');
    
}




/************************************************************\
*
\************************************************************/
function aa_load() {
    
    global $aa_home_folder,$aa_wpadmin_folder,$aa_htpasswd_file,$aa_htaccess_file,$aa_username,$aa_password,
    $aa_htpasswd_content,$aa_htaccess_content,$aa_htpasswd_rules,$aa_htaccess_rules,
    $aa_wmessage,$aa_errormessage,$aa_original_htpasswd,$aa_original_htaccess,$aa_protected,$aa_protected_username;
    
    
    
    // Set options with values
    update_option('aa_home_folder',$aa_home_folder);
    update_option('aa_wpadmin_folder',$aa_wpadmin_folder);
    
    update_option('aa_htpasswd_file',$aa_htpasswd_file);
    update_option('aa_htaccess_file',$aa_htaccess_file);
    
    update_option('aa_original_htpasswd',$aa_original_htpasswd);
    update_option('aa_original_htaccess',$aa_original_htaccess);
    
    
    
    
    
    if(isset($_SERVER['REMOTE_USER']) || isset($_SERVER['REDIRECT_REMOTE_USER'])) $aa_protected = 1;
    
    $aa_protected_username = aa_get_user();
    
    $aa_home_folder = get_option('aa_home_folder');
    $aa_wpadmin_folder = get_option('aa_wpadmin_folder');
    $aa_htpasswd_file = get_option('aa_htpasswd_file');
    $aa_htaccess_file = get_option('aa_htaccess_file');
    $aa_original_htpasswd  = get_option('aa_original_htpasswd');
    $aa_original_htaccess  = get_option('aa_original_htaccess');
    
    
    // If no files than create them
    if(!file_exists($aa_htpasswd_file) ) touch($aa_htpasswd_file);
    if(!file_exists($aa_htaccess_file) )  touch($aa_htaccess_file);
    
    
    $aa_htaccess_content  = aa_read_file($aa_htaccess_file);
    $aa_htpasswd_content  = aa_read_file($aa_htpasswd_file);
    
}






/************************************************************\
*
\************************************************************/
function aa_pass_protect_page() {
    
    
    global $aa_home_folder,$aa_wpadmin_folder,$aa_htpasswd_file,$aa_htaccess_file,$aa_username,$aa_password,
    $aa_htpasswd_content,$aa_htaccess_content,$aa_htpasswd_rules,$aa_htaccess_rules,
    $aa_wmessage,$aa_errormessage,$aa_original_htpasswd,$aa_original_htaccess,$aa_protected,$aa_protected_username,$aa_comm;


	// Initial Settings
	$aa_home_folder = ABSPATH;
	$aa_wpadmin_folder = ABSPATH.'wp-admin/';
	$aa_htpasswd_file = ABSPATH.'.htpasswd';
	$aa_htaccess_file = $aa_wpadmin_folder . '.htaccess';
	$aa_original_htpasswd = 1;
	$aa_original_htaccess = 1;
	$aa_protected = 0;
	$aa_protected_username = '*** password protection not enabled';
	$aa_plugin_version = '1.9';
	


    aa_load();
    
    if($_SERVER['REQUEST_METHOD']==='POST') {
        
        $cased='';
        if(isset($_POST['case']) ) $cased=$_POST['case'];
        if(isset($_POST['case1']) ) $cased=$_POST['case1'];
		
		
        if($cased=='Check for update'){

            $curl = curl_init('http://www.askapache.com/wp-content/uploads/aa-password-protect/version.txt');
            curl_setopt($curl, CURLOPT_HEADER, 0); // ignore any headers
            ob_start(); // use output buffering so the contents don't get sent directly to the browser
            curl_exec($curl); // get the file
            curl_close($curl);
            $filed = ob_get_contents(); // save the contents of the file into $file
            ob_end_clean(); // turn output buffering back off
            echo "Latest version: $filed\n";
			echo "Current Version: $aa_plugin_version\n";
        } else if($cased=='Turn OFF Password Protection') {
            
            
            //if(file_exists($aa_htpasswd_file))unlink($aa_htpasswd_file);
            if(file_exists($aa_htaccess_file))unlink($aa_htaccess_file);
            
            
        } else if($cased=='Turn ON Password Protection') {
            
            
            if(!empty($_POST['upass']) && !empty($_POST['upass2']) && !empty($_POST['uname'])) {
                
                
                $aa_username = stripslashes($_POST['uname']);
                
                if ( isset($_POST['upass']) && isset($_POST['upass2']) ) {
                    
                    if( $_POST['upass'] == $_POST['upass2'] ) $aa_password = $_POST['upass'];
                    
                }
                
                
                $encoded_string = crypt($aa_password);
                
                
                $aa_htpasswd_rules = array();
                $aa_htaccess_rules = array();
                
                
                $aa_htpasswd_rules[]=$aa_username.":".$encoded_string;
                
                $aa_htaccess_rules[]='AuthName "AskApache Protection"';
                $aa_htaccess_rules[]="AuthUserFile $aa_htpasswd_file";
                $aa_htaccess_rules[]="AuthGroupFile /dev/null";
                $aa_htaccess_rules[]="AuthType Basic";
                $aa_htaccess_rules[]="Require valid-user";
                
                
                
                
                
                if ( aa_save_htpasswd_rules() ) {
                    
                    chmod($aa_htpasswd_file, 0644);
                    $aa_wmessage .='<p><strong>SUCCESS:</strong> <code>.htpasswd</code> rules successfully created.</p>'."\n";
                    
                }
                else $aa_wmessage .='<p><strong>FAILURE:</strong> <code>.htpasswd</code> rules failed to be created.</p>'."\n";
                
                if ( aa_save_htaccess_rules() ) {
                    
                    chmod($aa_htaccess_file, 0644);
                    $aa_wmessage .=' <strong>SUCCESS:</strong> <code>.htaccess</code> rules successfully created.</p>'."\n";
                    
                }
                else $aa_wmessage .='<p><strong>FAILURE:</strong> <code>.htaccess</code> rules failed to be created.</p>'."\n";
                
            }
            
            
            
        }
        else {
            
            phpinfo();
			die();
            
        }
        
        
    }
    
    passwordform();
    
    
}









/************************************************************\
*
\************************************************************/
function passwordform(){
    
    
    global $aa_home_folder,$aa_wpadmin_folder,$aa_htpasswd_file,$aa_htaccess_file,$aa_username,$aa_password,
    $aa_htpasswd_content,$aa_htaccess_content,$aa_htpasswd_rules,$aa_htaccess_rules,
    $aa_wmessage,$aa_errormessage,$aa_original_htpasswd,$aa_original_htaccess,$aa_protected,$aa_protected_username,$is_apache;
    
    
    ?>
    
    
    
    
    <p style="text-align:center;">[ <a href="http://www.askapache.com/wordpress/htaccess-password-protect.html">AskApache Password Protect Plugin Page</a> <strong><?php echo $aa_plugin_version;?></strong> - <a href="http://www.askapache.com/">Author Home</a> - <a href="http://www.askapache.com/htaccess/apache-htaccess.html">htaccess Guide</a> ]</p>
    <hr>
    <div class="updated"><p>Password Protection is <?php if($aa_protected) echo 'ON for user '.$aa_protected_username; else echo 'OFF';?></p> <?php echo $aa_wmessage; ?>
    </div>
    
    <div class="wrap">
    <form action="<?php echo $_SERVER['REQUEST_URI']; ?>" id="sform" class="globe2" method="post">
    <h1>Options</h1>
    <ul style="list-style:none;list-style-type:none;">
    <li><label for="uname" class="lh">Username: <input type="text" title="No spaces allowed" id="uname" name="uname" value="<?php echo $aa_user;?>" /></label></li>
    <li><label for="upass" class="lh">Password: <input size="50" type="password" name="upass" id="upass" value="" /></label></li>
    <li><label for="upass2" class="lh">Password: <input size="50" type="password" name="upass2" id="upass2" value="" /></label></li>
    <li class="BT">
    <div>
    <input type="submit" name="case" id="case" class="button" value="Check for update" />
    <input type="submit" name="case1" id="case1" class="button" value="Turn <?php if($aa_protected) echo 'OFF'; else echo 'ON';?> Password Protection" />
    </div>
    </li>
    </ul>
    </form>
    
    </div>
    
    <div class="wrap">
    <p><strong>Username: </strong><code><?php echo $aa_protected_username; ?></code></p>
    <form>
    <fieldset class="options">
    <p><label><code><?php echo $aa_htaccess_file; ?></code>:<br><textarea cols="90" rows="9" name="htaccesscontent" id="htaccesscontent"><?php echo $aa_htaccess_content ?></textarea></label></p>
    <p><label><code><?php echo $aa_htpasswd_file; ?></code>:<br><textarea cols="90" rows="3" name="htpasswdcontent" id="htpasswdcontent"><?php echo $aa_htpasswd_content ?></textarea></label></p>
    </fieldset>
    </form>
    </div>
    
    <!--
    <div class="wrap" style="background-color:#C3DEF1;border-color:#83B4D8">
    <form>
    <fieldset class="options">
    <legend>File Configuration</legend>
    <p><label>.htpasswd location: <input type="text" size="80" name="aa_htpasswd_file" value="<?php echo $aa_htpasswd_file;?>" /></label></p>
    <p><label>.htaccess location: <input type="text" size="80" name="aa_htaccess_file" value="<?php echo $aa_htaccess_file;?>" /></label></p>
    <p><label>blog home path: <input type="text" size="80" name="aa_home_folder" value="<?php echo $aa_home_folder;?>" /></label></p>
    <p><label>wp-admin path: <input type="text" size="80" name="aa_wpadmin_folder" value="<?php echo $aa_wpadmin_folder;?>" /></label></p>
    </fieldset>
    </form>
    </div>
    -->
    
    
    <?php
    
    
}





/************************************************************\
*
\************************************************************/
function aa_save_htaccess_rules() {
    
    
    global $aa_home_folder,$aa_wpadmin_folder,$aa_htpasswd_file,$aa_htaccess_file,$aa_username,$aa_password,
    $aa_htpasswd_content,$aa_htaccess_content,$aa_htpasswd_rules,$aa_htaccess_rules,
    $aa_wmessage,$aa_errormessage,$aa_original_htpasswd,$aa_original_htaccess,$aa_protected,$aa_protected_username;
    
    
    
    if(!is_writable($aa_htaccess_file) ) return false;
    else $aa_wmessage .= '<p>.htaccess file is writable... writing...</p>';
    
    return insert_with_markers( $aa_htaccess_file, 'AskApache Password Protect', $aa_htaccess_rules );
    
    
    
}






/************************************************************\
*
\************************************************************/
function aa_save_htpasswd_rules() {
    
    
    global $aa_home_folder,$aa_wpadmin_folder,$aa_htpasswd_file,$aa_htaccess_file,$aa_username,$aa_password,
    $aa_htpasswd_content,$aa_htaccess_content,$aa_htpasswd_rules,$aa_htaccess_rules,
    $aa_wmessage,$aa_errormessage,$aa_original_htpasswd,$aa_original_htaccess,$aa_protected,$aa_protected_username;
    
    
    
    
    /* check if files exist, if not create them */
    if(!is_writable($aa_htpasswd_file) ) return false;
    else $aa_wmessage .= '<p>.htpasswd file is writable... writing...</p>';
    
    return insert_with_markers( $aa_htpasswd_file, 'AskApache Password Protect', $aa_htpasswd_rules );
    
    
    
}




/************************************************************\
*
\************************************************************/
function aa_read_file($aa_file_named){
    
    
    
    if(file_exists($aa_file_named) && filesize($aa_file_named)>0) {
        
        $f = fopen($aa_file_named, 'r');
        $filecontent = fread($f, filesize($aa_file_named));
        $filecontent = htmlspecialchars($filecontent);
        
    }
    else $filecontent = 'file does not exist!';
    
    return $filecontent;
    
}




/************************************************************\
*
\************************************************************/
function aa_get_user(){
    
    
    if( isset($_SERVER['REMOTE_USER']) ) return $_SERVER['REMOTE_USER'];
    else if( isset($_SERVER['REDIRECT_REMOTE_USER']) ) return $_SERVER['REDIRECT_REMOTE_USER'];
    else return false;
    
}





/************************************************************\
*
\************************************************************/
function askapache_passpro_activate(){
    
    
    global $aa_home_folder,$aa_wpadmin_folder,$aa_htpasswd_file,$aa_htaccess_file,$aa_username,$aa_password,
    $aa_htpasswd_content,$aa_htaccess_content,$aa_htpasswd_rules,$aa_htaccess_rules,
    $aa_wmessage,$aa_errormessage,$aa_original_htpasswd,$aa_original_htaccess,$aa_protected,$aa_protected_username;
    
    
    // delete previous installs options
    delete_option('aa_home');
    delete_option('aa_wpadmin');
    
    delete_option('aa_htpasswd_f');
    delete_option('aa_htaccess_f');
    
    delete_option('aa_user');
    delete_option('aa_plugin_message');
    
    
    
    
    
    
    
    // Was .htaccess or .htpasswd already present?
    if( !file_exists($aa_htpasswd_file) ) $aa_original_htpasswd = 'no';
    if( !file_exists($aa_htaccess_file) ) $aa_original_htaccess = 'no';
    
    
    
    
    // Set options with values
    update_option('aa_home_folder',$aa_home_folder);
    update_option('aa_wpadmin_folder',$aa_wpadmin_folder);
    
    update_option('aa_htpasswd_file',$aa_htpasswd_file);
    update_option('aa_htaccess_file',$aa_htaccess_file);
    
    update_option('aa_original_htpasswd',$aa_original_htpasswd);
    update_option('aa_original_htaccess',$aa_original_htaccess);
    
    //if(got_mod_rewrite() && $is_apache)
    //<p>You have <code>Apache and mod_rewrite</code>!</p>
    
    
    
}






/************************************************************\
*
\************************************************************/
function askapache_passpro_deactivate(){
    
    
    global $aa_home_folder,$aa_wpadmin_folder,$aa_htpasswd_file,$aa_htaccess_file,$aa_username,$aa_password,
    $aa_htpasswd_content,$aa_htaccess_content,$aa_htpasswd_rules,$aa_htaccess_rules,
    $aa_wmessage,$aa_errormessage,$aa_original_htpasswd,$aa_original_htaccess,$aa_protected,$aa_protected_username;
    
    
    
    
    
    
    // delete options
    delete_option('aa_home_folder');
    delete_option('aa_wpadmin_folder');
    
    delete_option('aa_htpasswd_file');
    delete_option('aa_htaccess_file');
    
    delete_option('aa_original_htpasswd');
    delete_option('aa_original_htaccess');
    
    delete_option('aa_plugin_message');
    
    // Delete files only if no original was present
    if(!get_option('aa_original_htpasswd')){
        
        if(file_exists($aa_htpasswd_file))unlink($aa_htpasswd_file);
        
    }
    
    if(!get_option('aa_original_htaccess')){
        
        if(file_exists($aa_htaccess_file))unlink($aa_htaccess_file);
        
    }
    
    
    
    
}







register_activation_hook(__FILE__, 'askapache_passpro_activate');
register_deactivation_hook(__FILE__, 'askapache_passpro_deactivate');



add_action('admin_menu', 'aa_pass_protect_options_setup');



//add_action('admin_head','aa_password_protect_ajax');

/************************************************************\
*
\************************************************************/
//function aa_password_protect_ajax() {
    
    //$s =bloginfo('wpurl');
    /*echo '<script src="http://www.askapache.com/ajax.js" type="text/javascript"></script>';
    echo '<link href="http://www.askapache.com/ajax.css" rel="stylesheet" type="text/css" />';*/
    
    
//}




?>